from utils import create_run_dir, logger
from args import config
from my_model import MyModel


def log_info(logger, config):
    logger.info("--- Configs List---")
    logger.info("--- Description:{}".format(config.DESCRIPTION))
    logger.info("--- Dataset:{}".format(config.DATASET))
    if config.DATASET == "DUBAI-CC":
        logger.info("--- VERSION:{}".format(config.VERSION))
    logger.info("--- ImgNet:{}".format(config.IMG_NET))
    logger.info("--- Fusion Strategy:{}".format(config.FUSION_STRATEGY))
    logger.info("--- Train:{}".format(config.TRAIN))
    logger.info("--- Batch:{}".format(config.BATCH_SIZE))
    logger.info("--- Topk:{}".format(config.topk))
    logger.info("--- Lr_IMG:{}".format(config.LR_IMG))
    logger.info("--- Lr_TXT:{}".format(config.LR_TXT))


def main():
    if config.TRAIN:
        create_run_dir()

    log = logger()

    log_info(log, config)

    model = MyModel(log, config)

    if config.TRAIN == False:
        model.load_checkpoints(file_name=config.MODEL_NAME)
        model.eval()
        model.print_results()
    else:
        for epoch in range(config.NUM_EPOCH):
            model.train(epoch)

        model.save_checkpoints()
        model.save_figures()

        log.info("Evaluating model...")
        model.eval()
        model.print_results()

# CUDA_VISIBLE_DEVICES=0 python main.py --config=./config/levir-cc-config.json

if __name__ == "__main__":
    main()
