import matplotlib.pyplot as plt

from args import config


def save_loss_over_epochs(losses):
    plt.figure(figsize=(20, 10))
    plt.plot(
        range(len(losses)),
        losses,
        label="Loss",
        color="gray",
    )
    plt.xlabel("Epoch")
    plt.ylabel("Loss")
    plt.title("Loss over Epochs")
    plt.tight_layout()
    plt.savefig(f"{config.FIGURE_DIR}/loss.png", dpi=300)
